@echo off
echo.
echo.
echo.
echo.
echo.
echo.
echo.                           BiG World Unpack v8.4
echo.
echo.
echo.
echo.   This is an alternative tool for the BiG World Setup.
echo.   Currently the BiG World Setup cannot handle neither newer mod versions
echo.   than discribed in the BiG World Guide nor additional mods.
echo.
echo.   This tool requires to be in the BiG World Downloads folder together with
echo.   the compressed files.
echo.
echo.   You will find the unpacked mods in the folder BiG World Downloads\
echo.   unpacked mods.
echo.
echo.
echo.
echo.
pause
IF NOT EXIST "unpacked mods" MD "unpacked mods"
IF NOT EXIST "special case" MD "special case"
IF NOT EXIST "Infinity Animations" MD "Infinity Animations\restore" "Infinity Animations\content"

:: The following mods are packed in a compressed file format that cannot be unpacked automatically.
IF EXIST Assassinations_v6.zip MOVE Assassinations_v6.zip ".\special case"
IF EXIST BanterPacksV9.zip MOVE BanterPacksV9.zip ".\special case"
IF EXIST BoM_Item_pack.rar MOVE BoM_Item_pack.rar ".\special case"
IF EXIST CespyAudioV1.zip MOVE CespyAudioV1.zip ".\special case"
IF EXIST deArniseV2.zip MOVE deArniseV2.zip ".\special case"
IF EXIST D0QuestPack_v23.exe MOVE D0QuestPack_v23.exe ".\special case"
IF EXIST D0Tweak_v20.exe MOVE D0Tweak_v20.exe ".\special case"
IF EXIST DungeonCrawl_v4.zip MOVE DungeonCrawl_v4.zip ".\special case"
IF EXIST GharethNPC.zip MOVE GharethNPC.zip ".\special case"
IF EXIST JZ_v2.exe MOVE JZ_v2.exe ".\special case"
IF EXIST KelseyNPCv21.zip MOVE KelseyNPCv21.zip ".\special case"
IF EXIST KelseyTOBV22.zip MOVE KelseyTOBV22.zip ".\special case"
IF EXIST Keto-SOAv3.zip MOVE Keto-SOAv3.zip ".\special case"
:: IF EXIST "Kiara-Zaiya 1.6.exe" MOVE "Kiara-Zaiya 1.6.exe" ".\special case"
IF EXIST KitanyaSoAv6-22.exe MOVE KitanyaSoAv6-22.exe ".\special case"
IF EXIST LuxleySoA_v1_1.zip MOVE LuxleySoA_v1_1.zip ".\special case"
IF EXIST Nathaniel_v4_2.zip MOVE Nathaniel_v4_2.zip ".\special case"
IF EXIST NeJ2v42b.exe MOVE NeJ2v42b.exe ".\special case"
IF EXIST NeJ2v602.exe MOVE NeJ2v602.exe ".\special case"
IF EXIST NPCFlirtV102.zip MOVE NPCFlirtV102.zip ".\special case"
IF EXIST RE_v4.exe MOVE RE_v4.exe ".\special case"
IF EXIST Shed__s_Mods_1.01.exe MOVE Shed__s_Mods_1.01.exe ".\special case"
IF EXIST Tiax_v1.exe MOVE Tiax_v1.exe ".\special case"
IF EXIST TOD-v3.2.exe MOVE TOD-v3.2.exe ".\special case"
IF EXIST TurnaboutV1.zip MOVE TurnaboutV1.zip ".\special case"
IF EXIST Xan_v8.zip MOVE Xan_v8.zip ".\special case"
IF EXIST XanBG1Friend_v5.zip MOVE XanBG1Friend_v5.zip ".\special case"
IF EXIST XanBG2Voice_v2.exe MOVE XanBG2Voice_v2.exe ".\special case"
IF EXIST Yikari_v1.5.exe MOVE Yikari_v1.5.exe ".\special case"

:: The following content needs to be extracted into Infinity Animations subfolders.
IF EXIST Belhifet_and_Marilith.zip MOVE Belhifet_and_Marilith.zip ".\Infinity Animations"
IF EXIST IA_Base_Anims.rar MOVE IA_Base_Anims.rar ".\Infinity Animations"
IF EXIST IA_BGII_IWDII.rar MOVE IA_BGII_IWDII.rar ".\Infinity Animations"
IF EXIST IA_Fiends_Genies.rar MOVE IA_Fiends_Genies.rar ".\Infinity Animations"
IF EXIST IA_IWD.rar MOVE IA_IWD.rar ".\Infinity Animations"
IF EXIST IA_IWD_Svirfneblin.rar MOVE IA_IWD_Svirfneblin.rar ".\Infinity Animations"
IF EXIST IA_NWN_01_Modron_v2.rar MOVE IA_NWN_01_Modron_v2.rar ".\Infinity Animations"
IF EXIST IA_PST_Abishai.rar MOVE IA_PST_Abishai.rar ".\Infinity Animations"
IF EXIST IA_Wh_Dr_Wyv_LoP.rar MOVE IA_Wh_Dr_Wyv_LoP.rar ".\Infinity Animations"
IF EXIST NWN_Misc_I.rar MOVE NWN_Misc_I.rar ".\Infinity Animations"
IF EXIST Shadows_harpy_frostgiant.zip MOVE Shadows_harpy_frostgiant.zip ".\Infinity Animations"
IF EXIST InfinityAnimations_WeiDU_b1.rar 7z.exe e -y -o".\Infinity Animations\content" ".\Infinity Animations\*.rar"
IF EXIST InfinityAnimations_WeiDU_b1.rar 7z.exe e -y -o".\Infinity Animations\content" ".\Infinity Animations\*.zip"
IF EXIST IA_BG2_Restores.rar MOVE IA_BG2_Restores.rar ".\Infinity Animations"
IF EXIST InfinityAnimations_WeiDU_b1.rar IF EXIST ".\Infinity Animations\IA_BG2_Restores.rar" 7z.exe e -y -o".\Infinity Animations\restore" ".\Infinity Animations\IA_BG2_Restores.rar"


:: The following mods are packed in a compressed file format that can be unpacked automatically.
:: IF EXIST BoM_Item_pack.rar MOVE BoM_Item_pack.rar ".\temp"

7z.exe x -y -o".\unpacked mods" *.7z
7z.exe x -y -o".\unpacked mods" *.exe
7z.exe x -y -o".\unpacked mods" *.rar
7z.exe x -y -o".\unpacked mods" *.zip

IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\restore\*.bam" ".\unpacked mods\infinityanimations\restore"

IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\content\*.2da" ".\unpacked mods\infinityanimations\content"
IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\content\*.bam" ".\unpacked mods\infinityanimations\content"
IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\content\*.bmp" ".\unpacked mods\infinityanimations\content"
IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\content\*.ogg" ".\unpacked mods\infinityanimations\content"
IF EXIST InfinityAnimations_WeiDU_b1.rar move ".\Infinity Animations\content\*.wav" ".\unpacked mods\infinityanimations\content"


:: The following mods are packed wrongly
CD ".\unpacked mods"

IF EXIST ".\PlanarSphereMod26c" Move ".\PlanarSphereMod26c\*.*" "."
IF EXIST ".\PlanarSphereMod26c" Move /Y ".\PlanarSphereMod26c\planarspheremod" "."
IF EXIST ".\PlanarSphereMod26c" RD /Q ".\PlanarSphereMod26c"

IF EXIST "RotB Armor Set v1.0" del ".\RotB Armor Set v1.0\SETUP-ROTBARMORSET.DEBUG"
IF EXIST "RotB Armor Set v1.0" Move ".\RotB Armor Set v1.0\*.*" "."
IF EXIST "RotB Armor Set v1.0" Move /Y ".\RotB Armor Set v1.0\RotBArmorSet" "."
IF EXIST "RotB Armor Set v1.0" RD /Q ".\RotB Armor Set v1.0"

IF EXIST "SKIE v.5.1" MOVE "SKIE v.5.1\*.*" "."
IF EXIST "SKIE v.5.1" MOVE "SKIE v.5.1\Skie" "."
IF EXIST "SKIE v.5.1" RD /Q ".\SKIE v.5.1"

IF EXIST "StuffofTheMagi v4" Move ".\StuffofTheMagi v4\*.*" "."
IF EXIST "StuffofTheMagi v4" Move /Y ".\StuffofTheMagi v4\StuffofTheMagi" "."
IF EXIST "StuffofTheMagi v4" RD /Q ".\StuffofTheMagi v4"

IF EXIST "uniqueartifacts_v1.12" Move ".\uniqueartifacts_v1.12\*.*" "."
IF EXIST "uniqueartifacts_v1.12" Move /Y ".\uniqueartifacts_v1.12\uniqueartifacts" "."
IF EXIST "uniqueartifacts_v1.12" RD /Q ".\uniqueartifacts_v1.12"

IF EXIST "ToBR beta 4" Move ".\ToBR beta 4\*.*" "."
IF EXIST "ToBR beta 4" Move /Y ".\ToBR beta 4\tobr" "."
IF EXIST "ToBR beta 4" RD /Q ".\ToBR beta 4"

IF EXIST "ts25mini" REN ".\ts25mini" ".\ts25mini_v2"
IF EXIST "ts25mini_v2" Move ".\ts25mini_v2\*.*" "."
IF EXIST "ts25mini_v2" Move /Y ".\ts25mini_v2\ts25mini" "."
IF EXIST "ts25mini_v2" RD /Q ".\ts25mini_v2"

IF EXIST "Quayle Project" Move ".\Quayle Project\*.*" "."
IF EXIST "Quayle Project" Move /Y ".\Quayle Project\Quayle" "."
IF EXIST "Quayle Project" RD /Q ".\Quayle Project"


IF EXIST "Paladins_of_Faerun_Kitpack_V4" Move ".\Paladins_of_Faerun_Kitpack_V4\Setup-Pofkits.exe" "."
IF EXIST "Paladins_of_Faerun_Kitpack_V4" Move /Y ".\Paladins_of_Faerun_Kitpack_V4\PofKits" "."
IF EXIST "Paladins_of_Faerun_Kitpack_V4" RD /Q ".\Paladins_of_Faerun_Kitpack_V4"

CD ..

:: 7z.exe x -y -o".\temp\extracted" ".\temp\*.rar 
:: 7z.exe x -y -o".\unpacked mods" .\temp\extracted\*.exe


echo.
echo.
echo.
echo.
echo.   Now most files are extracted. But still there are some special cases.
echo.   Some modders like to use their own installer that cannot be unpacked
echo.   automatically. These mods will now be started.
echo.
echo.   For each one you are prompted to choose a directory where the mods shall
echo.   be installed. Don't choose the default game folder but the folder
echo.   "BiG World Download\unpacked mods" because otherwise the installation
echo.   will be executed. Copy the entire path to your ...\BiG World Downloads\
echo.   unpacked mods directory before you continue and paste it into the input
echo.   field for the destination folder in the installer window.
echo.
echo.   The installation will start, but then interrupt with an error message 
echo.   because there is no CHITIN.KEY file. Don't worry about it! Quit the
echo.   DOS window. After the affected mods are unpacked they will also be
echo.   in the folder "BiG World Downloads\unpacked mods".
echo.
echo.   Sorry for the trouble but I cannot handle this in a better way.
echo.
echo.
echo.
echo.
pause

7z.exe x -y -o".\special case\unzipped" ".\special case\*.zip 


IF EXIST ".\special case\unzipped\Assassinations_v6.exe" ".\special case\unzipped\Assassinations_v6.exe"
IF EXIST ".\special case\unzipped\BanterPackV9.exe" ".\special case\unzipped\BanterPackV9.exe"
IF EXIST ".\special case\unzipped\BoM_Item_pack.exe" ".\special case\unzipped\BoM_Item_pack.exe"
IF EXIST ".\special case\unzipped\CespyAudioV1.exe" ".\special case\unzipped\CespyAudioV1.exe"
IF EXIST ".\special case\unzipped\dearniseV2.exe" ".\special case\unzipped\dearniseV2.exe"
IF EXIST ".\special case\D0QuestPack_v23.exe" ".\special case\D0QuestPack_v23.exe"
IF EXIST ".\special case\D0Tweak_v20.exe" ".\special case\D0Tweak_v20.exe"
IF EXIST ".\special case\unzipped\DungeonCrawl_v4.exe" ".\special case\unzipped\DungeonCrawl_v4.exe"
IF EXIST ".\special case\unzipped\GharethNPC.exe" ".\special case\unzipped\GharethNPC.exe"
IF EXIST ".\special case\JZ_v3.exe" ".\special case\JZ_v3.exe"
IF EXIST ".\special case\unzipped\KelseyNPCv21.exe" ".\special case\unzipped\KelseyNPCv21.exe"
IF EXIST ".\special case\unzipped\KelseyTOBV22.exe" ".\special case\unzipped\KelseyTOBV22.exe"
IF EXIST ".\special case\unzipped\Keto-SOAv3.exe" ".\special case\unzipped\Keto-SOAv3.exe"
:: IF EXIST ".\special case\Kiara-Zaiya 1.6.exe" ".\special case\Kiara-Zaiya 1.6.exe"
IF EXIST ".\special case\KitanyaSoAv6-22.exe" ".\special case\KitanyaSoAv6-22.exe"
IF EXIST ".\special case\unzipped\LuxleySoA-v1-1.exe" ".\special case\unzipped\LuxleySoA-v1-1.exe"
IF EXIST ".\special case\unzipped\Nathaniel-v4-2.exe" ".\special case\unzipped\Nathaniel-v4-2.exe"
IF EXIST ".\special case\NeJ2v42b.exe" ".\special case\NeJ2v42b.exe"
IF EXIST ".\special case\NeJ2v602.exe" ".\special case\NeJ2v602.exe"
IF EXIST ".\special case\unzipped\NPCFlirtV102.exe" ".\special case\unzipped\NPCFlirtV102.exe"
IF EXIST ".\special case\RE_v4.exe" ".\special case\RE_v4.exe"
IF EXIST ".\special case\Shed__s_Mods_1.01.exe" ".\special case\Shed__s_Mods_1.01.exe"
IF EXIST ".\special case\Tiax_v1.exe" ".\special case\Tiax_v1.exe"
IF EXIST ".\special case\TOD-v3.2.exe" ".\special case\TOD-v3.2.exe"
IF EXIST ".\special case\unzipped\TurnaboutV1.exe" ".\special case\unzipped\TurnaboutV1.exe"
IF EXIST ".\special case\unzipped\Xan_v8.exe" ".\special case\unzipped\Xan_v8.exe"
IF EXIST ".\special case\unzipped\XanBG1Friend_v5.exe" ".\special case\unzipped\XanBG1Friend_v5.exe"
IF EXIST ".\special case\XanBG2Voice_v2.exe" ".\special case\XanBG2Voice_v2.exe"
IF EXIST ".\special case\Yikari_v1.5.exe" ".\special case\Yikari_v1.5.exe"
echo.
echo.
echo.
echo.
echo.    After installation of the first mod all the others will be updated.
echo.    (Maybe happen later again.) Be patient, don't close the window.
echo.
echo.
echo.    You will get the message:
echo.
echo.       ERROR: Unable to find DIALOG.TLK in:
echo.       dialog.tlk
echo.       Please run this program in your Infinity Engine game directory.
echo.       FATAL ERROR: Failure("Unable to find DIALOG.TLK")
echo.
echo.    That is intended, because now the mod shall only be unpacked, not
echo.    installed to the game.
echo.    Press ENTER to exit. Then the other mods will be installed.
echo.
echo.
echo.    Only when all mods are installed, close all DOS windows except this
echo.    one before continue!
echo.
echo.
pause

IF EXIST ".\unpacked mods\SETUP-*.DEBUG" del ".\unpacked mods\SETUP-*.DEBUG"
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.    finished!
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
pause

