:: If you want to edit this file for personal usage only jump to EDITING
:: Wenn Ihr diese Datei nur fr den persnlichen Gebrauch bearbeiten mchtet, springt zu EDITING

:: Change %INST% to %INSTQ% in the relevant mod in order to choose the components individually during installation.

:: To uninstall a single component or specific components for testing purposes:
:: setup-##.exe	 --language 0  --force-uninstall-list #
:: replace ## with the modname and # with the component number(s) and 0 if necessary with the actual language number.
:: To uninstall a complete mod for testing purposes:
:: setup-##.exe	 --language 0  --uninstall
:: Caution: Only if you know exactly what you are doing! You could ruin your whole installation!

:: Within a codeblock there may only be used "rem" instead of colons "::"

:: findstr and logical operations:
:: A AND B: findstr /I /M "A" txt>nul && findstr /I /M "B" txt>nul
:: A OR B: findstr /I /M "A B" txt>nul 
:: (A AND B) OR C: findstr /I /M "A C" txt>nul && findstr /I /M "B C" txt>nul
:: (A OR B) AND C: findstr /I /M "A B" txt>nul && findstr /I /M "C" txt>nul

@echo off

SET IF=IF EXIST
SET IFN=IF NOT EXIST
SET S=.exe Setup-
SET L=.exe --language 
SET SK= --skip-at-view --force-install-list
SET .=echo.
SET MOD=.exe echo      
SET OV=.\override\
SET MAC=%IFN% BGConfig.exe
SET NMAC=%IF% BGConfig.exe
SET GOG=%IF% goggame.dll
SET NGOG=%IFN% goggame.dll

SET BWFP=BiG World Fixpack
SET BWIP=BiG World Installpack
SET BWSP=BiG World Smoothpack
SET BWTP=BiG World Textpack
SET BWBP=BiG World Trimpack

SET C="%BWIP%"\cut -c5-
SET M="%BWIP%\mtee.exe" /+ "BiG World Debug.txt"
SET OV=.\override\
SET E="BiG World Explanation.txt"

SET IFE=%IF% BWP_English
SET IFF=%IF% BWP_French
SET IFG=%IF% BWP_German
SET IFH=%IF% BWP_Spanish
SET IFI=%IF% BWP_Italian
SET IFP=%IF% BWP_Polish
SET IFR=%IF% BWP_Russian
SET IFL=%IF% BWP_Language
SET IFNE=%IFN% BWP_English
SET IFNF=%IFN% BWP_French
SET IFNG=%IFN% BWP_German
SET IFNH=%IFN% BWP_Spanish
SET IFNR=%IFN% BWP_Russian

SET IFSD=%IF% BWP_Standard
SET IFT=%IF% BWP_Tactic
SET IFX=%IF% BWP_Expert
SET IFND=%IFN% BWP_Standard
SET IFNT=%IFN% BWP_Tactic
SET IFNX=%IFN% BWP_Expert

SET IFS=%IF% Setup-
SET IFNS=%IFN% Setup-
SET IF2=%IF% BWP_BG2only
SET IFN2=%IFN% BWP_BG2only 

SET AD=%IF% BWP_Adult
SET AO=BWP_AOE_Kits
SET DU=%IF% BWP_Deselect_Unsuitable
SET DF=%IF% BWP_Deselect_Fun
SET NDU=%IFN% BWP_Deselect_Unsuitable
SET NDF=%IFN% BWP_Deselect_Fun

SET IFSI=%IFSD% %IF%
SET IFSN=%IFSD% %IFN%
SET IFSS=%IFSD% %IFS%
SET IFTS=%IFT% %IFS%
SET IFXS=%IFX% %IFS%
SET IFNXS=%IFNX% %IFS%
SET IFNMS=%IFN% BWP_More %IFS%
SET IFNTS=%IFNT% %IFS%
SET IFIF=.exe %IFS%
SET IFNIF=.exe %IFNS%
SET IFES=%IFE% %IFS%
SET IFENS=%IFE% %IFNS%
SET IFFS=%IFF% %IFS%
SET IFFNS=%IFF% %IFNS%
SET IFGS=%IFG% %IFS%
SET IFGNS=%IFG% %IFNS%
SET IFHS=%IFH% %IFS%
SET IFHNS=%IFH% %IFNS%
SET IFRS=%IFR% %IFS%
SET IFSNS=%IFSD% %IFNS%
SET IFTNS=%IFT% %IFNS%
SET IFXNS=%IFX% %IFNS%

SET TXT=type "%CD%\%BWIP%\temp\strings.txt"
SET TXT1=type "%CD%\%BWIP%\temp\general.txt"

SET TXTE=type "%BWIP%\English\"
SET TXTG=type "%BWIP%\German\"
SET TXTH=type "%BWIP%\Spanish\"
SET TXTR=type "%BWIP%\Russian\"
SET INST="%BWIP%\Install.bat"
SET INSTQ="%BWIP%\Install_q.bat"

%IF% BWP_InstQ (
SET INSTI="%BWIP%\Install_q.bat"
) else (
SET INSTI="%BWIP%\Install.bat"
)

SET NQ=%IFN% BWP_InstQ
SET TEM=.\%BWFP%\_temp\override

:: Every choice-key may be used only one single time.
:: These keys are already used:

:: (A)sian
:: (B)GT	(at game selection)
:: (C)ontinue   (at check)
:: (D)eselect
:: (E)nglish
:: (F)rench
:: (G)erman
:: (H)ispanic
:: (J)a		(at Textharmonisation)
:: s(K)ip	(at Widescreen)
:: (L)anguage	(non-English Installation only)
:: (M)ore
:: (N)o		(at Textharmonisation)
:: BG2 (O)nly	(at game selection
:: (P)olish
:: (R)ecommended
:: (S)tandard
:: (T)actic
:: U Animal Companions agree
:: V Animal Companions rename
:: (W)idescreen
:: e(X)pert
:: (Y)es	(at TOBCHECK)
:: don't (Z)oom it	(at Widescreen)

:: Q - may not be used, because it will close the window immediately

Call ".\%BWIP%\config.bat"

:: EDITING
%.%
%.%
%.%1. CORRECTIONS AND IMPROVEMENTS | %M%
%.%
%.%
%IFG% Call %INST% TP "0"
%IFF% Call %INST% correcfr "0"
%IFH% Call %INST% Traduccion_Mejorada "0"

Call %INSTI% TobEx "100 101 102 105 107 108 109 111 112 113 114 115 116 117 118 120 121 122 123 124"
%IFNS%spell_rev.exe Call %INST% TobEx "103"

%IFX% Call %INSTI% Ascension "0 1 2 3 4 5"

%IFX% Call %INST% TheUndying "1 2"

%IFX% Call %INST% Oversight "0"

Call %INST% bg2fixpack "0"
%IFE% Call %INSTI% bg2fixpack "1000"
Call %INSTI% bg2fixpack "3 100 101 102 103 104 106 107 108 109 110 111 112 113 114 115 116"

%IFSD% Call %INSTI% BDToBv168 "0 2 3 7"
%IFT% Call %INSTI% BDToBv168 "5"

%IFSD% Call %INST% iiKeyNames "2001"

%IFN% .\1pp\core\1ppv4_pro Call %INSTI% 1pp "0 2 7 8 9"
Call %INSTI% 1pp "101"
%IFN% setup-item_rev.exe Call %INSTI% 1pp "200" 1
%IF% setup-item_rev.exe Call %INSTI% 1pp "200" 2
%.%
%.%
%.%2. NEJ | %M%
%.%
%.%
:: %IFXS%NeJ2%IFNIF%NeJ2v691%IFNIF%NeJ2v68.exe Call %INST% NeJ2Biffer "0"
:: now we need the files unbiffed in the override
%IFX% %IFNS%NeJ2v691%IFNIF%NeJ2v68.exe (
Call %INSTI% NeJ2 "0 7 8 9 10"
%IFN% BWP_CNoNEJImoen %IF2% Call %INST% NeJ2 "1"
)

findstr /I /M "NEJ2.TP2~.*#.*#7./" WeiDU.log>nul
if %errorlevel%==0 (
%IFN% BWP_CNoNEJImoen %IFN2% %IFSNS%NeJ2v691%IFNIF%NeJ2v68.exe Call %INST% BGTNeJ "0"
%IFNS%NeJ2v691%IFNIF%NeJ2v68.exe Call %INST% NeJ2v602 "0"
%IFN% BWP_CKeepYosh %IFS%TS-BP%IFNIF%NeJ2v691.exe Call %INST% NeJ2v602 "2"
%IFNS%NeJ2v691%IFNIF%NeJ2v68.exe copy /Y ".\%BWFP%\_override\NEJ2\*.*" ".\override" | %M%
%IFS%randomiser%IFNIF%NeJ2v691.exe copy /Y ".\NeJ2\NEJ-BIFF\override\obsdem01.cre" ".\override" | %M%
)
%.%
%.%
%.%3. BIG BG2 MODS PRE BGT | %M%
%.%
%.%
%IFSD% Call %INST% SOS "0"

%IFSD% Call %INST% CtB "0"
findstr /I /M "CTB.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% CtB-Chores "0"
Call %INST% CtB_FF "0"
Call %INST% CtBcutImp "0"
)

%IFN% BWP_CKeepYosh %IFSNS%NeJ2v691%IFNIF%NeJ2v68%IFNIF%TS.exe Call %INST% TS-BP "0"

findstr /I /M "CTB.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% TethyrForestPatch "0"
) else (
%IFS%TethyrForestPatch.exe %TXT% | findstr @365 | %C% >> %E%
)

%IFSN% BWP_COctDrizzt Call %INST% RoT "0 1"

findstr /I /M "SOS.TP2~.*#.*#0./ CtB.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "RoT.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
copy /Y ".\RoTerror\anim\Yeti\*.bam" ".\override" | %M%
)

%.%
%IF2% GOTO :SKIPBG1
%.%
%.%4. BGT | %M%
%.%
%.%
%.%
%.%
%.%
%.%
:: path for BG1
%NMAC% %IFS%BGT.exe %TXT% | findstr @089 | %C%
:: %MAC% %IFS%BGT.exe %TXT% | findstr @389 | %C%
%.%
%.%
%.%
%.%
%.%
Call %INST% BGT "0" "TYPE BWP_BGT_input.txt"

Call %INST% BGTMusic "2"

%IFN2% Call %INST% bggraphics "0" "TYPE bggraphics_input.txt"

%IFNS%JA#BGT_AdvPack.exe Call %INST% JondalarFix "0"

%IFG% Call %INST% TP "1"

%IFG% Call %INST% BGT-NPCSound "0" 2>NUL
:: Don't worry about the "error: unrecognized file signature, must be..." messages

Call %INST% TxtMusic "0"

:SKIPBG1
%.%
%.%
%.%5. BIG BG2 MODS PAST BGT | %M%
%.%
%.%
%IFN% BWP_CSharTeel %IFN% BWP_CEllesime Call %INST% TDD "0 1"

findstr /I /M "NEJ2.TP2~.*#.*#7./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSNS%NeJ2v691%IFNIF%NeJ2v68.exe (
Call %INST% BGTNeJ2 "0"
%IFN% BWP_CSharTeel %IFN% BWP_CBG1NPCSoA Call %INST% BGTNeJ2 "3"
) else (
%IFN% BWP_CNoNEJImoen Call %INST% BGTNeJ "0"
)
%IFX% Call %INSTI% BGTNeJ "2 4"
Call %INSTI% BGTNeJ "5 6 7"
)

%IF% ".\%BWFP%\_temp\tisunpack.exe" copy ".\%BWFP%\_temp\tisunpack.exe" "*.*" | %M%

%IFNS%NeJ2v691.exe (
Call %INSTI% NeJ2v68 "0 7 8 10"
%IFX% Call %INSTI% NeJ2v68 "3 5"
%IFN% BWP_CNoNEJImoen Call %INST% NeJ2v68 "1"
%IFN% BWP_CSharTeel %IFN% BWP_CBG1NPCSoA Call %INST% NeJ2v68 "6"
)

%IFX% (
Call %INSTI% NeJ2v691 "0 3 5 7 8 9 10 12"
%IFN% BWP_CNoNEJImoen Call %INST% NeJ2v691 "1"
%IFN% BWP_CSharTeel %IFN% BWP_CBG1NPCSoA Call %INST% NeJ2v691 "6"
)
findstr /I /M "NEJ2V691.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% NeJ2v694 "0"
)

:: for all versions of NEJ
%IF% .\NEJ2 copy /Y ".\%BWFP%\_override\NEJ2\*.*" ".\override" | %M%

%IFN% BWP_CKeepYosh (
%IFNS%TS-BP.exe Call %INST% TS "0 3"
%IFNS%NeJ2v691%IFNIF%NeJ2v68%IFNIF%NEJ2%IFNS%TS-BP.exe Call %INST% TS "1 2"
)

%IFS%TS.exe copy ".\%BWFP%\_override\GUI_original_fonts\*.*" ".\override" | %M%

%IF2% GOTO :SKIPBG2
%.%
%.%
%.%6. BIG BG1 MODS | %M%
%.%
%.%
%IFT% Call %INST% DarkHorizons "0"

%IFSD% Call %INSTI% DSotSC "5 100 200 400 410 420 430 440 450 460 470 480"

%IFSD% Call %INST% NTotSC "0"
findstr /I /M "NTOTSC.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% NTotSCv171 "0"
)

%IFSD% Call %INST% BoneHillv275 "0"

%IFSD% Call %INST% drizztsaga "1 3"
%.%
%.%
%.%7. BG1 QUEST MODS | %M%
%.%
%.%
%IFT% (
Call %INST% Vault "0"
%IF% setup-item_rev.exe CALL %INST% vault "1"
)
Call %INST% bgqe "0"

Call %INST% TGC1E "0"

Call %INST% SirinesCall "0"

%IFS%SOA.exe copy /Y ".\%BWFP%\_override\worldmap\*.*" ".\override" | %M%
Call %INST% SOA "0"

Call %INST% AC_QUEST "0"

%IFSD% Call %INST% NMT "0"
%.%
%.%
%.%8. BG1 STORES AND ITEMS | %M%
%.%
%.%
%IFSD% Call %INST% BW_Herbs "0"

%IFSD% Call %INST% thalan "0"

%IFSD% Call %INSTI% LostItems "0 1 2"

%IFSD% Call %INST% BGeeAR "0"

%IFSD% Call %INST% BGeeW "0"
%.%
%.%
%.%9. BG1 NPC MODS | %M%
%.%
%.%
Call %INSTI% bg1npc "0 1 2 3 4 5 6 7 8"
Call %INSTI% bg1npc "9" 1
Call %INSTI% bg1npc "10" 1
%AD% Call %INSTI% bg1npc "11" 1
Call %INSTI% bg1npc "12" 1
%AD% Call %INSTI% bg1npc "13" 1
Call %INSTI% bg1npc "14" 1
Call %INSTI% bg1npc "15 17 25 27 30 200"
findstr /I /M "BG1NPC.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% BG1NPCMusic "0"
)

%IFSD% Call %INST% IndiNPC "0"

%IFSD% Call %INST% Mur'Neth "0"

%IFSD% Call %INST% MulgoreXaviaNPC "0"

Call %INST% XanBG1Friend "0"

Call %INST% coranbgfriend "0"

Call %INST% AjantisBG1 "0"

Call %INST% ACBre "0" "TYPE ACBre_input.txt"

%IFGS%FinchNPCv3.exe del ".\finch\audio\IMOEN28.WAV" | %M%
Call %INST% FinchNPCv3 "0"

Call %INST% gavin "0 1" 1
%AD% Call %INST% gavin "2"
Call %INST% gavin "4 10"

%IFSD% Call %INSTI% Huple_NPC "0 1"

Call %INST% ChaosKnight "0"

findstr /I /M "ChaosKnight.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% Askaria "0"
) else (
%IFS%Askaria.exe %TXT% | findstr @352 | %C% >> %E%
)

Call %INST% valerie "0"

Call %INSTI% isra "0 1 2"

Call %INST% White "0"

%IFSN% BWP_CGarricktales Call %INST% garrick_flirt "0" 1

%IFSN% BWP_CGarrickflirt Call %INST% garrick-tt "0" 1
%.%
%.%
%.%10. BG1 RULES AND TWEAKS | %M%
%.%
%.%
Call %INSTI% bg1ub "0 1 2"
:: components 3, 4, 5, 6, 7 will be skipped, if BG1 NPC Project is installed
findstr /I /M "BG1NPC.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%bg1ub.exe %TXT% | findstr @300 | %C% >> %E%
) else (
Call %INSTI% bg1ub "3 4 5 6 7"
)
Call %INSTI% bg1ub "8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24"
findstr /I /M "BG1NPC.TP2~.*#.*#30./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%bg1ub.exe %TXT% | findstr @302 | %C% >> %E%
) else (
Call %INSTI% bg1ub "27"
)

%IFSD% Call %INSTI% BGSpawn "0 1 3" 3
%IFT% Call %INSTI% BGSpawn "2"

Call %INSTI% ktweaks "1 2 3 301"
:: Ktweaks component #3 needs to be installed if component #2 is installed

%IFN% BWP_C1PP Call %INST% item_rev "0 1"

%IFSD% Call %INSTI% BDToBv168 "6"

Call %INSTI% kittomes "0 4 5"

:SKIPBG2
%.%
%.%
%.%11. BG2 QUEST MODS | %M%
%.%
%.%
Call %INSTI% ToA "1 10 20 30 40 50"

Call %INST% GBThfKp "0"

findstr /I /M "TDD.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% AjocMod "0"
) else (
%IFS%AjocMod.exe %TXT% | findstr @303 | %C% >> %E%
)

%IFSD% Call %INST% TTSQ "0"

%IFSD% Call %INSTI% emad "0 1 2 3 4 5"

%IFSD% Call %INSTI% PlanarSphereMod "0 1 2 3"

%AD% %NDF% Call %INSTI% tb#quest "0"
%AD% %NDF% %IFT% Call %INSTI% tb#quest "1"
%IFS%refinements.exe Call %INSTI% tb#quest "2"
%IFSD% Call %INSTI% tb#quest "3"

%IFSD% Call %INST% BWQuest "0"

Call %INST% c#sb_silber "0"

%IFSD% Call %INSTI% spgaunt "0 1 3"

Call %INST% TOD "0"
%IFT% Call %INST% TOD "1 2"

Call %INST% DC "0"

Call %INST% Assassinations "0"

Call %INST% BackBrynnlaw "0"

Call %INST% Sellswords "0"

%IFSD% Call %INST% 1Sylm "0"

Call %INST% sovereign "0 1"

Call %INST% TotDG "0 1 2"

Call %INSTI% Innershade "0 2 6"

Call %INSTI% WhiteQueen "0" 2

Call %INST% RUKRAKIA "0"

Call %INST% ISNF "0"

%IFSD% Call %INSTI% ts25mini "0 1 2 3 4 5"

%IFX% Call %INST% Devin "0"

%IFSD% Call %INST% Eilistraee "0 2"

%IFSD% Call %INSTI% dq "0 1 2"
%.%
%.%
%.%12. BG2 Tactical Encounters | %M%
%.%
%.%
%IFT% Call %INST% AzenMOD "0 1 2"

%IFT% Call %INST% com_encounters "0 1 2"

%IFT% Call %INSTI% DSoA "1"
findstr /I /M "BDTOBV168.TP2~.*#.*#5./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%DSoA.exe %TXT% | findstr @304 | %C% >> %E%
) else (
%IFT% Call %INSTI% DSoA "2"
)
%IFTNS%BP.exe Call %INSTI% DSoA "3 5 7"
%IFT% Call %INSTI% DSoA "4 6 8"

%IFT% Call %INST% DofD "0"

%IFT% Call %INSTI% impasylum "0 1 2 3"

%IFT% Call %INST% Firkraag "0"

%IFT% Call %INST% imnesvale "1"

%IFT% %NDU% Call %INST% DNT "0"

%IFT% Call %INST% Arena "0"

%IFT% %NDU% Call %INST% UoT "0"
%.%
%.%
%.%13. BG2 STORES AND ITEMS | %M%
%.%
%.%
%IFSD% Call %INST% AM "0"

%IFSD% Call %INST% BagBonus "0"

%IFSD% Call %INST% RGenie "0"

%IFSD% Call %INST% BoM "0"

%IFSD% Call %INST% BG2SoA "1"

%NDU% %IFX% Call %INST% Exnem "0 1 2"

%IFSD% Call %INSTI% FR_ROV "0 1"

%IFSD% Call %INST% HeartWood "0"

%IFSD% Call %INST% BW_Herbs_BG2 "0"

findstr /I /M "ITEM_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%ValHorn.exe %TXT% | findstr @305 | %C% >> %E%
) else (
%IFSD% Call %INST% ValHorn "0"
)

%IFSD% Call %INST% KWolf "0"

%IFSD% Call %INST% MunchMod "0"

%IFSD% Call %INSTI% RItemPack "0 1 2 3 4 5 6 7 8"

%IFSD% Call %INST% Rolles "0"
%IFSNS%Item_Pack.exe Call %INST% Rolles "1"

%IFSD% Call %INST% rttitempack "0"

%IFSD% Call %INST% Ruad "0 1"

%IFSD% Call %INST% Tzshop01 "0"

%IFSD% Call %INST% AbyStore "0"

%IFSD% Call %INST% Underrep "0"

%IFSD% Call %INSTI% ItemUpgrade "10 11"

%IFX% Call %INSTI% spitems "2 3"

Call %INST% cliffkey "1"

Call %INST% BloodMort "0"

Call %INSTI% Ebg2 "0 1 2 4 5 6 7 9 14 15 18"
findstr /I /M "TDD.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%Ebg2.exe %TXT% | findstr @306 | %C% >> %E%
) else (
%IFSD% Call %INSTI% Ebg2 "8 10 11 12 13 16 17"
)

%IFSD% Call %INST% foodmod "0"

%IFSD% Call %INST% rupert "0"

%IFSD% Call %INST% VolcanicArmoury "0"

%IFSD% Call %INST% RotBArmorSet "0"

%IFSD% %IFNT% Call %INST% StuffofTheMagi "0" "TYPE StuffofTheMagi_input_S.txt"
%IFT% Call %INST% StuffofTheMagi "0" "TYPE StuffofTheMagi_input_T.txt"

%IFSNS%ashesofembers%IFNIF%Kitanya%IFNIF%RPG-KP.exe Call %INSTI% KonTwk "0"
%IFSNS%aTweaks.exe Call %INSTI% KonTwk "9"
%IFSD% Call %INSTI% KonTwk "11 13 14 15"

%IFSD% Call %INST% bolsa "0"

%IFSD% Call %INST% Charli "0"

%IFSD% Call %INST% DARRON "0"

%IFSD% Call %INST% nanstein "0"

%IFSD% Call %INST% Mhoram "0"

%IFSD% Call %INST% Vendedor_DLAN "0 1"

%IFSD% Call %INST% Recarga "0"

%IFSD% Call %INST% Alchemy "0"

%IFSD% Call %INST% SPSTUFF "4"

%IFSD% Call %INST% MERSKSTORE "0"

%IFSD% Call %INST% MYSTIGAN "0"

%IFSD% Call %INST% LavaIt "0"

%IFSD% Call %INST% OLDMODSPACK "0"

%IFSD% Call %INST% RFWIP "0"

Call %INST% HOUYI "0"

Call %INST% YLITEMS "0"

%IFSD% Call %INST% DragonSummon "0" 1

%IFT% Call %INST% dsr "0"

:: The following 7 items can be added to a character only by CLUA-Console or with Unique Containers!
%IFSD% Call %INST% BBBKBG "0"
%IFSD% Call %INST% BBPBAG "0"
%IFSD% Call %INST% BBQUIV "0"
%IFSD% Call %INST% BBQUIVB "0"
%IFSD% Call %INST% BBQUIVC "0"
%IFSD% Call %INST% BBSCCS "0"
%IFSD% Call %INST% BBSCARDR "0"

%IFSD% Call %INST% musica "0"

%IFSD% Call %INST% swordap "0"

%IFSD% Call %INST% portablehole "0"

%IFSD% Call %INST% renal "0"

%IFSD% Call %INST% trovador "0"

%IFSD% Call %INST% Haendlermod "0"

%IFSD% Call %INSTI% iwditempack "0 1 2 3 4 5 6 7 8 9 10 11"
findstr /I /M "IWDITEMPACK.TP2~.*#.*#./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% iwditemfix "0"
)

%NDU% Call %INST% sigil-bd-mod "0"

%NDU% Call %INST% d2item "0"
%.%
%.%
%.%14. BG2 NPC MODS | %M%
%.%
%.%
Call %INST% Amber "0"

%IFSD% Call %INST% Severian "0"

%IFSD% Call %INSTI% BTL "0 1 2 3"

%IFN% BWP_CBG1NPCSoA (
%IFN% BWP_Adult Call %INSTI% ajantisbg2 "0" "TYPE ajantisbg2_input.txt"
%AD% Call %INSTI% ajantisbg2 "0" "TYPE ajantisbg2_adult_input.txt"
)
%IFSD% Call %INST% Tashia "0 2"

%IFN% BWP_CTDDEllesime %IFN% BWP_CKhalid %IFN% BWP_CBG1NPCSoA Call %INSTI% Kivan "0 2 6 7"

%IFSD% Call %INST% Fade "0"

Call %INST% Kido "0 1"

Call %INST% Ariena "0 1"

%IFSD% Call %INST% Kindrek "0"

%IFSN% BWP_CKhalid (
Call %INST% kitanya "0"
%IFNS%wsr.exe Call %INST% kitanya "1"
)
%IFSD% Call %INST% Star "0"

%IFSD% Call %INST% Valen "0"

%AD% Call %INST% tsukibg2 "0 1"

%IFN% BWP_CKhalid %IFN% BWP_CBG1NPCSoA Call %INSTI% Xan "0 3 5"
findstr /I /M "XAN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFND% Call %INST% XanBG2Voice "0"
)

%IFSD% Call %INST% Yasraena "0"

%IFSN% BWP_CBG1NPCSoA Call %INST% alora "0"

Call %INST% AurenAseph "0"

%IFSD% Call %INST% Thael "0"

%IFSD% Call %INSTI% Hanna "0 1 3 4 5 6"

%IFSD% Call %INST% KIM "0 1"

%IFSD% Call %INST% Lester "0"

%IFN% BWP_CBG1NPCSoA Call %INST% Tiax "0"

Call %INST% sarahtob "0"

%IFSD% Call %INSTI% Hubelpot "0 1"

Call %INST% Angelo "0"

%IFSD% Call %INSTI% VampireTales "0"
%IFT% Call %INSTI% VampireTales "1 2"
%IFSD% Call %INSTI% VampireTales "3"

%IFSD% Call %INST% Nikita "0"

%IFSD% Call %INST% touched "0 1"

%IFSN% BWP_CTDDEllesime %IFSD% Call %INST% ninde "0"

%IFSD% Call %INSTI% xulaye "0 1 2"

Call %INST% haldamir "0"

%IFSD% Call %INST% AVIM "0"

%IFSN% BWP_CTDDEllesime %IFSD% Call %INST% Saerileth "0"

%IFSN% BWP_CBG1NPCSoA Call %INST% Skie "0"

%IFSN% %AO% Call %INST% worgas "0"
findstr /I /M "NEJ2.TP2~.*#.*#7./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%worgas.exe %TXT% | findstr @307 | %C% >> %E%
) else (
%IFSN% %AO% Call %INST% worgas "1"
)
%IFSN% %AO% %IFN% BWP_CRoTDrizzt %IFN% BWP_COctDrizzt Call %INST% worgas "2"

%IFSD% Call %INST% TyrisFlare "0"

%IFSD% Call %INST% Varshoon "0 1"

Call %INSTI% gavin_bg2 "0" 1
Call %INSTI% gavin_bg2 "1 2"

findstr /I /M "GAVIN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% gavin_kickout_hotfix "0"
)

findstr /I /M "GAVIN.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "GAVIN_BG2.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% gavin_bg2_bgt "0"
)

%IFSD% Call %INST% darian "0 4"

%IFSD% Call %INST% Aeon "0"
findstr /I /M "XAN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% Aeon "1"
)
%IFSD% Call %INST% Aeon "2"

%IFSD% Call %INST% Yvette "0" "TYPE Yvette_input.txt"
%IFSD% Call %INST% Yvette "1"

Call %INST% adrian "0"

Call %INST% arath "0"

Call %INST% dace "0"

Call %INST% Gahesh "0"

Call %INST% Lena "1"

Call %INST% isra_bg2 "0"
%.%
%.%
%.%15. BG2 ONE-DAY NPCS | %M%
%.%
%.%
%IFSD% Call %INST% alassa "0"

%IFSD% Call %INST% allison "0"

%IFSD% Call %INST% anishai "0"

%IFSD% Call %INST% BonsBrucev2 "0"

%IFSD% Call %INST% cassius "0"

%IFSD% Call %INST% Ghareth "0"

%IFSD% Call %INST% HessaNPC "0"

%IFSD% Call %INST% JCBruce "0"

%IFSNS%WikaedeR.exe Call %INST% Wikaede "0"
%IFSD% Call %INST% WikaedeR "0"

%IFSD% Call %INST% WillyB "0"

%IFSD% Call %INST% FoxMonster "0"

%IFSD% Call %INST% Vildra "0"

%IFSD% Call %INST% Jandor "0"

%IFSN% BWP_CBG1NPCSoA %IFSD% Call %INST% Eldoth "0"

%IFSD% Call %INST% Roar "0"

%IFSD% Call %INST% Teddy "0"

:: Call %INST% abSolestia "0"
%.%
%.%
%.%16. BG2 NPC-RELATED MODS | %M%
%.%
%.%
%NDF% Call %INST% Cws "0"

%NDF% Call %INST% JZ "0"

%IFN% BWP_CDArnise %IFX% Call %INST% LuvNalia "0"

%IFN% BWP_CLuvNalia Call %INST% deArnise "0"

%IFSD% Call %INST% Chloe "0"

Call %INSTI% BanterPack "0 2 3"

findstr /I /M "BG1NPC.TP2~.*#.*#25./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BanterPack.exe %TXT% | findstr @308 | %C% >> %E%
) else (
Call %INST% BanterPack "1"
)

%IFN% BWP_CKhalid Call %INSTI% iepbanters "0 1 2 3 4 5"

Call %INST% viconia "0"

Call %INST% mazzy "0"

%IFN% BWP_CKeepYosh Call %INST% yoshimo "0"

%IFSN% BWP_CYoshFriend Call %INST% #yoshi "0"

%IFSN% BWP_CKeepYosh Call %INSTI% YoshimoRomance "0 1 4"

%IFSD% Call %INSTI% EdwinRomance "0 2 3"

%IFSD% Call %INST% Tsujatha "0"

%IFN% BWP_CKhalid %IFN% BWP_CImoenFriend %IFN% BWP_CImoenNEJ Call %INST% Imoen "0"

%IFSD% Call %INST% alcool "0"

%IFSD% Call %INST% JanQuest "0"

Call %INST% Korgan "0"

%IFN% BWP_CImoenRom Call %INST% imoenfriendship "0"

%IFSN% BWP_CKhalid %IFN% BWP_CCoranBG2 %IFN% BWP_CBG1NPCSoA Call %INST% Coran "0 1"

%IFSN% BWP_CNoKkalid (
Call %INSTI% Khalid "0" "TYPE Khalid_input.txt"
Call %INSTI% Khalid "1 5"
)

findstr /I /M "ROT.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "DRIZZTSAGA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
findstr /I /M "bg1npc.TP2~.*#.*#12./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%THEONEDRIZZT.exe %TXT% | findstr @382 | %C% >> %E%
) else (
rem Call %INST% THEONEDRIZZT "0"
)
)

%IFSD% Call %INST% LaValygar "0"

%IFSN% BWP_CBG1NPCSoA Call %INST% yeslicknpc "0"

Call %INST% sarevokfriendship "0"

Call %INST% Branwen "0"
%.%
%.%
%.%17. MORE BG2 NPC MODS | %M%
%.%
%.%
%IFX% Call %INST% cliffhistory "0"

Call %INST% Chiara "0"

%IFSN% BWP_CRoTDrizzt Call %INST% DKDrizzt "0"

%IFX% Call %INST% Elvan-all "0 1"

%IFSD% Call %INST% Goo "0"

%IFSD% Call %INST% Horace "0 1"

%IFSD% Call %INST% Kari "0"

%IFSD% Call %INST% Malthis "0"

%IFSN% BWP_CTDDSharTeel %IFN% BWP_CBG1NPCSoA Call %INST% sharteel "0 1"

%IFSD% Call %INST% SBS "0 1"

%IFSD% Call %INST% Vanim "0"

%IFSD% Call %INST% BIDDE "0"

%IFX% Call %INST% Azure "0 1"

%IFSD% Call %INST% frennedan "0"

%IFSN% BWP_CBranwen %IFN% BWP_CBG1NPCSoA Call %INST% POB "0"

%IFSNS%NeJ2v691%IFNIF%NeJ2v68.exe %IFN% BWP_CPerils %IFN% BWP_CBG1NPCSoA Call %INST% BranwenNPC "0"

%IFSD% Call %INST% MawgulNPC "0"

%IFSD% Call %INST% Uldar "0"

%IFSD% %IFN2% Call %INST% rose "0"

%IFSD% Call %INST% Larsha "0"

%IFSD% Call %INST% Raziel "0"

%IFSN% BWP_CBG1NPCSoA Call %INST% Quayle "0"

%IFSD% Call %INST% gloran "0"

%IFSD% Call %INST% Auden "0"

:: much too much errors
:: %IFSD% Call %INST% stivan "0"

findstr /I /M "NeJ2v68.TP2~.*#.*#6./ NeJ2v691.TP2~.*#.*#6./ BGTNEJ2.TP2~.*#.*#3./ SHARTEEL.TP2~.*#.*#0./ YESLICKNPC.TP2~.*#.*#0./ POB.TP2~.*#.*#0./ BRANWENNPC.TP2~.*#.*#0./ SKIE.TP2~.*#.*#0./ ELDOTH.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @372 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "0"
)
findstr /I /M "CORAN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @374 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "10"
)
findstr /I /M "ALORA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @375 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "20"
)
findstr /I /M "ajantisbg2.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @376 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "30"
)
findstr /I /M "TDD.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @377 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "40 70"
)
%IFSD% Call %INSTI% BG1NPCSoA "50"
findstr /I /M "KIVAN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @378 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "60"
)
findstr /I /M "XAN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @379 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "80"
)
findstr /I /M "QUAYLE.TP2~.*#.*#0./ TIAX.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG1NPCSoA.exe %TXT% | findstr @380 | %C% >> %E%
) else (
Call %INSTI% BG1NPCSoA "90"
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "100"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#4./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "110"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#9./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "120"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "130"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#70./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "140"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#20./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "150"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#30./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "160"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#60./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "170"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#80./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "180"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "190"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
findstr /I /M "BG1NPCSOA.TP2~.*#.*#50./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "200"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @310 | %C% >> %E%
)
%IFSD% Call %INSTI% BG1NPCSoA "229"
findstr /I /M "BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#10./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#20./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#30./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#40./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#60./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#70./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#80./" WeiDU.log>nul && findstr /I /M "BG1NPCSOA.TP2~.*#.*#90./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG1NPCSoA "230"
) else (
%IFS%BG1NPCSoA.exe %TXT% | findstr @309 | %C% >> %E%
)

Call %INST% Coondred "0"
%.%
%.%
%.%18. MINI-MODS | %M%
%.%
%.%
%NDF% Call %INST% aip "0"

%IFSD% Call %INST% SDMODS "0"

%IFSD% Call %INST% TurnipGolem "0"

%NDF% Call %INST% MDX "0"

%NDF% Call %INST% hf_HHG "0"

%IFSD% Call %INST% QualloFix "0"

%IFX% Call %INST% cal "0"

%IFX% Call %INST% Questor "0"

%IFSD% Call %INST% SNAKES "0"

%IFSD% Call %INST% Contest "0"

%IFSD% Call %INST% BWL_Contest "0"

%IFSD% Call %INST% ThOghma "0"

%IFSD% Call %INSTI% ShardsOfIce "0 1 2"

%NDF% Call %INST% SkooterTheNPC "0"

Call %INST% lucy "0"

%IFSD% Call %INST% Cerberus "0"

Call %INST% slandor "0"

%IFSD% Call %INST% Zalnoya "0 1"

%NDF% Call %INST% Swylif "0"

%IFSD% Call %INST% sagaman "0"

Call %INST% Almaquest2 "0"
%.%
%.%
%.%19. BG2 RULES AND TWEAKS | %M%
%.%
%.%
%IFSD% Call %INST% npc_tweak "0 1 2"

findstr /I /M "TS-BP.TP2~.*#.*#0./ TS.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%UB.exe %TXT% | findstr @311 | %C% >> %E%
) else (
Call %INST% UB "1"
)
%IFT% Call %INSTI% UB "3"
Call %INSTI% UB "0 2 4 5 6 7 8 9 10 11 12 15 16 17 18 19 21 25"
findstr /I /M "ITEM_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%UB.exe %TXT% | findstr @312 | %C% >> %E%
) else (
Call %INSTI% UB "20"
)
%IFNS%BP%IFNIF%turnabout%IFNIF%#yoshi.exe Call %INSTI% UB "24"

Call %INSTI% arestorationp "0 1 2 3 4 5 6 7"

%IFSD% Call %INST% ghost "0"

%IFX% Call %INST% FamiliarPack "0"

%IFX% Call %INSTI% Vic "0 1 2 3 4 5 6 7 9"

Call %INST% fadingpromises "0"

Call %INSTI% spell_rev "0 10 20 30 40 50"

%IFX% Call %INST% fairydragon "0"

%IFX% Call %INST% semi_multi_clerics "0"

%IFSD% Call %INSTI% SpellPackB6 "1116 1119 1113 1105 1131 1106 1109 1110 1151 1217 1223 1203 1206 1242 1243 1246 1250 1211 1213 1302 1328 1336 1313 1309 1310 1347 1348 1350 1351 1353 1354 1361 1419 1422 1427 1431 1405 1449 1453 1458 1459 1518 1503 1517 1506 1535 1539 1540 1541 1515 1544 1603 1621 1628 1637 1614 1645 1720 1705 1740 1743 1716 1728 2102 2103 2104 2117 2105 2107 2119 2116 2125 2217 2203 2204 2238 2224 2240 2207 2211 2253 2213 2219 2215 2331 2304 2303 2317 2305 2307 2308 2314 2315 2401 2402 2412 2404 2405 2450 2413 2459 2425 2501 2508 2502 2503 2506 2511 2514 2505 2549 2615 2614 2605 2616 2619 2607 2648 2731 2713 2736 2721 2716 2743 2714 2812 2821 2827 2810 2814 2915 2911 2912 2909 2913"

%IFXNS%IMPROVEDSUMMONS.exe Call %INSTI% Spell50 "0 1 2"

%IFSD% Call %INSTI% WildMage "0 3 4"

%IFSD% call %INST% Teleport "0 1"

%IFSD% %IFN2% Call %INST% DrizztIsNotStupid "0"

%IFSD% Call %INST% TheUndying "0"

%IFSD% Call %INST% Neh'taniel "0"

%IFSD% Call %INST% nogameover "100"

%IFSD% Call %INST% DungeonBeGone "0"

%IFNS%stratagems%IFNIF%BG1NPC.exe Call %INST% parting "0 2"

Call %INST% pcvamp "0"

%IFSD% Call %INST% Haiass "0 10"

%IFSD% Call %INST% Drows "0"

:: %IFX% Call %INST% Mortis_V23 "0"
:: not together with Worgas or Raziel (and maybe some other mods) because it causes the game to crash.
%.%
%.%
%.%20. ASCENSION-RELATED MODS | %M%
%.%
%.%
Call %INST% res_fixer "0"

findstr /I /M "THEUNDYING.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BP.exe copy /Y ".\%BWFP%\_TheUndying_for_BP\*.*" ".\BP\SNIP" | %M%
)

%IF% ".\override\.itm" del ".\override\.itm"
Call %INSTI% BP "0 10 35 50 60"

::BP Encounter Components
%IFT% Call %INSTI% BP "1020 1080 1100 1110 1120 1130 1140 1170 1175 1190 1200 1210 1250 1275 1300 1315 1330 1350 1375 1400 1425 1450 1525 1570 1600 1625 1650 1675 1700 1800"
%IFN% BWP_SCS_AI %IFT% Call %INST% BP "1225 1750"

findstr /I /M "ASCENSION.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BP.exe %TXT% | findstr @381 | %C% >> %E%
) else (
%IFSD% Call %INSTI% BP "2000"
%IFND% Call %INSTI% BP "2100 2200 2300 2400 2500 2600"
)

%IFSD% Call %INSTI% d0questpack "0 1 11"

%IFTNS%RevisedBattles.exe Call %INSTI% Tactics "0"
%IFT% Call %INSTI% Tactics "1 3 8 9 13 14 31 32 33 37"

findstr /I /M "BP.TP2~.*#.*#150./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFT% Call %INSTI% Tactics "6 7 12 24 28 29 36"
)

findstr /I /M "BP.TP2~.*#.*#1175./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFT% Call %INSTI% Tactics "11"
)

findstr /I /M "BP.TP2~.*#.*#1120./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFT% Call %INSTI% Tactics "15"
)

findstr /I /M "BP.TP2~.*#.*#1400./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFT% Call %INSTI% Tactics "17 18"
)

findstr /I /M "BP.TP2~.*#.*#600./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFT% Call %INSTI% Tactics "20"
)

%IFN% BWP_BP_AI %IFT% Call %INSTI% Tactics "2 4 5 10 16 21 22 23 25 34 35"
%IFTNS%d0questpack.exe Call %INSTI% Tactics "30"

findstr /I /M "ASCENSION.TP2~.*#.*#0./ BP.TP2~.*#.*#2000./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% Turnabout "0 1"
) else (
%IFS%Turnabout.exe %TXT% | findstr @320 | %C% >> %E%
)

findstr /I /M "ASCENSION.TP2~.*#.*#0./ BP.TP2~.*#.*#2100./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% LongerRoad "0 2"
%.% Don't worry about the Warning: "coefficients were truncated. Max. truncated value" 
) else (
%IFS%LongerRoad.exe %TXT% | findstr @321 | %C% >> %E%
%IFS%LongerRoad%IFIF%BP.exe %TXT% | findstr @322 | %C% >> %E%
)

Call %INST% wheels "0"

%IFSD% Call %INST% Celestials "0"

%IFSD% Call %INSTI% Grimuars "0 1"
%IFTNS%RevisedBattles.exe Call %INSTI% Grimuars "2"
%IFT% Call %INSTI% Grimuars "3 4"

Call %INST% homewardbound "0 2"

%IFX% Call %INSTI% tobr "0 1 2 3 4 5 6 7 8 9 10 11 12 13"
%.%
%.%
%.%21. KELSEY/SOLAUFEIN RELATED NPC MODS | %M%
%.%
%.%
Call %INST% Solaufein "0"

findstr /I /M "SOLAUFEIN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% rpgsolaflirtpack "0"
) else (
%IFS%rpgsolaflirtpack.exe %TXT% | findstr @313 | %C% >> %E%
)

%IFSD% Call %INST% Sheena "0"

Call %INST% Kelsey "0"
findstr /I /M "SOLAUFEIN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% Kelsey "1"
) else (
%IFS%Kelsey.exe %TXT% | findstr @369 | %C% >> %E%
)
findstr /I /M "ASCENSION.TP2~.*#.*#0./ BP.TP2~.*#.*#2000./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% Kelsey "4"
) else (
%IFS%Kelsey.exe %TXT% | findstr @370 | %C% >> %E%
)

findstr /I /M "Kelsey.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
call %INST% GRoA "0"
) else (
%IFS%GRoA.exe %TXT% | findstr @314 | %C% >> %E%
)

%IFSN% BWP_CKeepYosh Call %INST% Keto "0 1"

Call %INST% Nathaniel "0 1 4 5"

%IFSD% Call %INST% LuxleySoA "0 1 2"

%AD% %IFSD% Call %INSTI% Kiara-Zaiya "0 1 2"
%AD% %IFT% Call %INSTI% Kiara-Zaiya "3 4 6"
%AD% %IFX% Call %INSTI% Kiara-Zaiya "5"
findstr /I /M "BP.TP2~.*#.*#1250./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%Kiara-Zaiya.exe %TXT% | findstr @315 | %C% >> %E%
) else (
%AD% %IFT% Call %INSTI% Kiara-Zaiya "7"
)

:: depended of the installed IteUpgrade components either 1 and 2 or 4 and 5 will be skipped
%IFSD% Call %INSTI% Yikari "0 1 2 3 4 5"

Call %INSTI% iylos "0 1 6"

%IFSD% Call %INSTI% Faren "0 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24"

%AD% Call %INSTI% NPCFlirt "0 2 4 6 8 10 12 14"
findstr /I /M "SOLAUFEIN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%AD% Call %INSTI% NPCFlirt "1 3 5 7 9 11 13 15"
) else (
%IFS%NPCFlirt.exe %TXT% | findstr @368 | %C% >> %E%
)

%IFSD% Call %INSTI% RE "0 3 4 7 8 11 14 15 16 17 18 19 20 21 22 23 24 26 27 28 29 30 32 33 35 37 39 40 43 44 45 46 47 49 50 51 52 53"
%IFSN% BWP_CCoranMod Call %INSTI% RE "10"
%AD% Call %INSTI% RE "1 2 5 6 9 12 13 25 31 34 36 38 41 42 48"

%AD% %IFSD% Call %INST% haerdalisromance "0"

%IFSD% Call %INST% nephele "0 1"

Call %INST% Petsy "0 1"

%IFT% Call %INSTI% RevisedBattles "0 1 2 3 4 5 6 7 8"
findstr /I /M "FIRKRAAG.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%RevisedBattles.exe %TXT% | findstr @316 | %C% >> %E%
) else (
%IFT% Call %INSTI% RevisedBattles "9"
)
findstr /I /M "NEJ2V691.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFT% Call %INSTI% RevisedBattles "10"
) else (
%IFS%RevisedBattles.exe %TXT% | findstr @354 | %C% >> %E%
)
%IFT% Call %INSTI% RevisedBattles "11 12 13 14 15 16 17 18 19 20 21 22"

Call %INST% RevisedBattles "23 24 25 26 27"

findstr /I /M "REVISEDBATTLES.TP2~.*#.*#24./" WeiDU.log>nul
if %errorlevel%==0 (
findstr /D:override /C:"B#BLADE" kit.ids > B#BLADEtemp.txt
more +1 B#BLADEtemp.txt > B#BLADEstring.txt
del B#BLADEtemp.txt
)

%IFX% Call %INSTI% d0questpack "5"
%IFSD% Call %INSTI% d0questpack "4 6 7 8 9 10 14 15 16 17 18 19 20 21"
findstr /I /M "#YOSHI.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%d0questpack.exe %TXT% | findstr @317 | %C% >> %E%
) else (
%IFSD% Call %INSTI% d0questpack "13"
)

%IFSD% Call %INSTI% RezMod "0 1 2 3"

Call %INST% alternatives "0"

%NDF% Call %INST% G3Anniversary "0"

Call %INST% sarevokromance "0"

Call %INSTI% CrossmodBG2 "0 1 2"

%IFN2% Call %INST% ACBre "2"
%.%
%.%
%.%22. INSTALLATION OF KITS | %M%
%.%
%.%
:: misc kits

%IFSD% Call %INSTI% npckit "30 31 400 900 2100 2200 2300 2500 2510 2800"

%IFSD% Call %INSTI% kitrtt "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30"

%IFSD% Call %INSTI% PPK "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17"

Call %INSTI% Crusade "0 1 2 3"

Call %INSTI% LOHMod "0 1 2 3 4 5 6"

Call %INSTI% IK "0 1 2 3 4 5 6 7"

Call %INSTI% HideKt "0 1 2 3 4 5 6 7 8 9 10 11 12 13"

Call %INSTI% Vagrant "0 1 2 3"

:: bard and thief kits
%IFSD% Call %INST% Conductor "0 1"
%IFSD% Call %INSTI% HarpScout "0 1 2"
Call %INSTI% Pirate "0 2 6"
Call %INST% lyric "0"
Call %INST% ChanterKit "0"
Call %INST% bardkit "0"

:: ranger and paladin kits
%IFSD% Call %INST% AurorKit "0"
%IFS%infinityanimations%IFIF%Bear_Animations_D2.exe Call %INST% BearWalker "0" "TYPE Bearwalker_input.txt"
Call %INST% AvengerKit "0 1 2 3"
Call %INST% Rodeur "0"
Call %INST% Storm "0"
Call %INST% zulu "0"

:: druid and cleric kits
Call %INST% SilverFur "0"
Call %INST% PBhaal "0"
Call %INST% HeartwarderKit "0"

:: fighter
%IFSD% Call %INST% elven_pack "0"
%IFSD% Call %INST% morituri "0"
%IFSD% Call %INST% RetaliatorKit "0"
%IFSD% Call %INST% werewarrior "0 1"
Call %INST% Chantelame "0"
Call %INST% x0black "0"
Call %INST% WarslingSniperKit "0"
Call %INST% JKits "0 1"
Call %INST% Run "0"
Call %INST% ArcaneArcher "0"
Call %INST% CustomKits "1"
Call %INST% Armiger "0"
Call %INST% SamuraiKit "0"
Call %INST% Tempest "0"
Call %INST% acidelem_beta1 "0"
%NDU% Call %INST% d2bar "0"
%NDU% Call %INST% d2pal "0"
%NDU% Call %INST% Jedi_Sith "0"



%IFSD% Call %INST% BGII-Subrace "0"
%IFSD% Call %INST% BGII-Subrace "1"
%.%
%.%
%.%23. HLA-TABLES CHANGING MODS | %M%
%.%
%.%
%IFX% Call %INSTI% ashesofembers "5 6 7 8 9 10 11"
findstr /I /M "ITEM_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%ashesofembers.exe %TXT% | findstr @387 | %C% >> %E%
) else (
%IFX% Call %INSTI% ashesofembers "14 15"
)

:: install monks before
%IFX% Call %INSTI% Oversight "2 3 6 7"

:: install druids, clerics, paladin and rangers before
%IFSD% Call %INSTI% Divine_Remix "0 100 103 106 107 109 112 115 118 121 124 127 130 200 203 403 406 409 412 415 600"

findstr /I /M "DIVINE_REMIX.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INSTI% SPSTUFF "0 1 2 3 6"

%IFSD% Call %INSTI% PofKits "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18"
) else (
%IFS%PofKits.exe %TXT% | findstr @319 | %C% >> %E%
%IFS%SPSTUFF.exe %TXT% | findstr @371 | %C% >> %E%
)

Call %INST% phord_druidkits "0"

Call %INST% AnimalCompanions "0" "TYPE AnimalCompanions_input.txt"

:: install tieves and bards before
%IFSD% Call %INSTI% song_and_silence "0 1 2 3 4 5 6 7 8 9 10"

:: install fighters and monks before
%IFSD% Call %INSTI% sword_and_fist "1 30 31 32 33 34"

Call %INSTI% RR "0 1 3 4 6 7 8 9"

%IFT% Call %INSTI% RR "11"

%IFX% Call %INSTI% ashesofembers "0 2 3"
%IFX% %IFNS%wsr.exe Call %INSTI% ashesofembers "4"
%IFX% Call %INSTI% ashesofembers "12 18 19 20 21"
%IFNX% %IFNS%btweak%IFNIF%btweak_lite.exe Call %INSTI% ashesofembers "16 17"

%IFSD% Call %INSTI% Tactics "26 27"

findstr /I /M "ASHESOFEMBERS.TP2~.*#.*#4./ KONTWK.TP2~.*#.*#0./ KITANYA.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%WSR.exe %TXT% | findstr @386 | %C% >> %E%
) else (
%IFSD% Call %INST% WSR "100"
)

findstr /I /M "REVISEDBATTLES.TP2~.*#.*#24./" WeiDU.log>nul
if %errorlevel%==0 (
type B#BLADEstring.txt >> ./override/kit.ids
)

Call %INSTI% refinements "10 40 50"

Call %INSTI% DruidicSorcererKit "0 1"

Call %INSTI% druidsor "0"

Call %INSTI% RPG-KP "0 2 7 9 10 11 13"
findstr /I /M "CAL.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
Call %INSTI% RPG-KP "4 6"
)
findstr /I /M "CAL.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
Call %INST% RPG-KP "3"
)

Call %INSTI% Kitpack6 "0 1 2 3 4 5 6 7 8"

Call %INSTI% Derats_kits "0 1 2 5 7"
:: component 9 and 11 cause parse errors
findstr /I /M "NEJ2.TP2~.*#.*#0./ NeJ2v68.TP2~.*#.*#0./ NeJ2v691.TP2~.*#.*#0./ SOS.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
Call %INST% Derats_kits "3 4 6"
)

findstr /I /M "DIVINE_REMIX.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%spell_rev.exe %TXT% | findstr @318 | %C% >> %E%
) else (
Call %INST% spell_rev "60"
)

%.%
%.%
%.%24. MISC TWEAKS AND GRAFIC MODS | %M%
%.%
%.%
%IFSNS%btweak.exe Call %INSTI% btweak_lite "0 1 2 3 4 5 6"
%IFSD% Call %INSTI% btweak "0 1 2 22 23 24 25"

Call %INSTI% hammers "0 15 25 35 50"

Call %INSTI% Item_Pack "0 1 4 5 6 7 8 9"

%IFS%DungeonBeGone.exe %IF% ".\override\FWJASSY.CRE" move ".\override\FWJASSY.CRE" "%TEMP%" | %M%
%IFSD% Call %INST% iiItemMod "1"
%IFS%DungeonBeGone.exe %IF% "%TEMP%\FWJASSY.CRE" move "%TEMP%\FWJASSY.CRE" ".\override" | %M%

%IFN% BWP_FULLPLATE %IFT% Call %INSTI% item_rev "3 8 9"
Call %INSTI% item_rev "1020 1030 1050 10 11 12 13 1093 15 17 18"

findstr /I /M "ITEM_REV.TP2~.*#.*#17./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% ninjawakifix "0"
)

%IFX% Call %INST% UniqueArtifacts "2"
%IFXS%UniqueArtifacts.exe copy /Y uniqueartifacts\backup\2\TASLGURK.CRE ".\override" | %M%

%IFX% Call %INST% cursed_items "0"
%IFSD% Call %INST% cursed_items "10"

Call %INST% freeact "10"
findstr /I /M "ITEM_REV.TP2~.*#.*#0./ SPELL_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%freeact.exe %TXT% | findstr @359 | %C% >> %E%
) else (
Call %INST% freeact "50"
)

%IFX% Call %INSTI% Z#Misc "1 17 18 19"

%IFN% .\1pp\core\1ppv4_pro (
Call %INSTI% 1pp "1 3 4 5 6 10 11 12"

Call %INSTI% 1pp_avatars "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16"

Call %INSTI% 1pp_female_dwarves "0"

findstr /I /M "1pp_female_dwarves.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% 1pp_thieves_galore "1 2 3"
)
)

%MAC% Call %INSTI% 1pp "102"
%NMAC% Call %INSTI% 1pp "103"
%IF% BWP_PP1GUI Call %INSTI% 1pp "104" "TYPE 1PPGUI_input.txt"
Call %INSTI% 1pp "105 106 111 113 201"
findstr /I /M "3D Acceleration=1" baldur.ini
if %errorlevel%==0 (
Call %INSTI% 1pp "114" "1PP114_input.txt"
)
%IFS%SpellPackB6%IFIF%divine_remix.exe %IF% ".\override\SPPR342.SPL" move ".\override\SPPR342.SPL" "%TEM%" | %M%
%IF% ".\override\SPWI414.SPL" move ".\override\SPWI414.SPL" "%TEM%" | %M%
Call %INSTI% 1pp "202" 2
%IFS%SpellPackB6%IFIF%divine_remix.exe %IF% "%TEM%\SPPR342.SPL" move "%TEM%\SPPR342.SPL" ".\override" | %M%
%IF% "%TEM%\SPWI414.SPL" move "%TEM%\SPWI414.SPL" ".\override" | %M%
Call %INSTI% 1pp "203 204 207 210"
%IFN% BWP_CItem_Rev (
Call %INSTI% 1pp "205 206 208"
)
Call ".\%BWIP%\define_1PP400.bat
Call %INSTI% 1pp "400" "1PP400_input.txt"
Call %INSTI% 1pp "401"
Call %INSTI% 1pp "300" 1
Call %INSTI% 1pp "301"

Call %INSTI% infinityanimations "0 25 50 100 150 210 260 400 410 450 490 500 550 600 650 710 7000 9000"

Call %INST% Bear_Animations_D2 "0"

Call %INSTI% NSCPortraits "0 1 10 20 21 30 50 300 305 310 1000 1001 1030 1031 1300 1310 1320 1330 1340 1350 1360 1370 1380 1390 1400 1410 1420 1430 2000 2010 3000 3010 5000 5010"

%IFSD% %IFN2% Call %INST% JA#BGT_AdvPack "0"
findstr /I /M "NTotSC.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%JA#BGT_AdvPack.exe %TXT% | findstr @383 | %C% >> %E%
) else (
%IFSD% %IFN2% Call %INST% JA#BGT_AdvPack "1"
)
%IFSD% %IFN2% Call %INST% JA#BGT_AdvPack "2"
findstr /I /M "bg1npc.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%JA#BGT_AdvPack.exe %TXT% | findstr @384 | %C% >> %E%
) else (
%IFSD% %IFN2% Call %INST% JA#BGT_AdvPack "3"
)

%IFT% Call %INST% vecna "0"

%IFSD% Call %INST% w_packmule "0" "TYPE packmule_input.txt"

%IFSD% Call %INSTI% iwdification "30 40 60"
%IFNS%BardSong_BG2_IWD.exe Call %INSTI% iwdification "50"
%.%
%.%
%.%25. MAJOR TWEAKS | %M%
%.%
%.%
Call %INSTI% stratagems "1000"

Call %INSTI% stratagems "1901 1910 2000 2010 2020 2030 2041 2060 2070 2080 2090 2100 2110 2120 2130 2140 2150 2160 2170 2180 3030"
:: components 2000 2020 2030 2040 2041 2060 2070 2080 2090 2100 2140 2150 2160 will be skipped automatically if "Spell Revisions" is installed

%IFT% Call %INSTI% stratagems "3010 3020 3022 3041 3060 3070 3080 3090 3110"
:: components 3050 3060 3070 3080 3090 3100 3110 will be skipped automatically if "Spell Revisions" is installed

Call %INSTI% stratagems "4000 4010 4020 4040 4051 4110 4120 4130 4146 4160 4170 4180 4200 4210 4217 4230 4240 5000 5010 5020 5030 5050 5060 5900"
%IFN% BWP_BP_AI Call %INSTI% stratagems "6000 6010"

%IFN% BWP_BP_AI (
%IFNT% Call %INSTI% stratagems "6021"
%IFT% Call %INSTI% stratagems "6023"
)
findstr /I /M "Tactics.TP2~.*#.*#10./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @425 | %C% >> %E%
) else (
%IFN% BWP_BP_AI (
%IFNT% Call %INSTI% stratagems "6032 6042"
%IFT% Call %INSTI% stratagems "6031 6041"
)
)
Call %INSTI% stratagems "6101 6200 6300 6310 6320"

findstr /I /M "Tactics.TP2~.*#.*#20./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @420 | %C% >> %E%
) else (
%IFN% BWP_BP_AI Call %INSTI% stratagems "6500"
)

findstr /I /M "Tactics.TP2~.*#.*#12./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @421 | %C% >> %E%
) else (
%IFN% BWP_BP_AI (
%IFT% Call %INSTI% stratagems "6510"
%IFNT% Call %INSTI% stratagems "6511"
)
)
Call %INSTI% stratagems "6520"

%IFN% BWP_BP_AI (
%IFT% Call %INSTI% stratagems "6531"
%IFNT% Call %INSTI% stratagems "6530"
)
findstr /I /M "Tactics.TP2~.*#.*#22./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @422 | %C% >> %E%
) else (
%IFN% BWP_BP_AI %IFNT% Call %INSTI% stratagems "6541"
)
findstr /I /M "Tactics.TP2~.*#.*#23./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @423 | %C% >> %E%
) else (
%IFN% BWP_BP_AI (
%IFT% Call %INSTI% stratagems "6550"
%IFNT% Call %INSTI% stratagems "6551"
)
)
findstr /I /M "Tactics.TP2~.*#.*#21./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @424 | %C% >> %E%
) else (
%IFN% BWP_BP_AI (
%IFNT% Call %INSTI% stratagems "6560"
%IFT% Call %INSTI% stratagems "6561"
)
)
%IFN% BWP_BP_AI Call %INSTI% stratagems "6570"
findstr /I /M "SETUP-DEVIN.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%.%
) else (
%IFN% BWP_BP_AI Call %INSTI% stratagems "6580"
)
Call %INSTI% stratagems "6590"

findstr /I /M "ASCENSION.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFND% Call %INSTI% stratagems "6800 6810 8620 6830 6840 6850"
)

%IFT% Call %INSTI% stratagems "7000 7010 7020 7030 7040 7050 7060 7070 7080 7090 7100 7110 7130 7140 7200 7210 7220 7230 7240 7250 7900 8000 8010"

findstr /I /M "Tactics.TP2~.*#.*#13./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @426 | %C% >> %E%
) else (
%IFN% BWP_BP_AI %IFT% Call %INSTI% stratagems "8020"
)

findstr /I /M "Tactics.TP2~.*#.*#37./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @427 | %C% >> %E%
) else (
%IFT% Call %INSTI% stratagems "8030"
)

findstr /I /M "Tactics.TP2~.*#.*#16./ Tactics.TP2~.*#.*#25./ Tactics.TP2~.*#.*#34./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @428 | %C% >> %E%
) else (
%IFN% BWP_BP_AI Call %INSTI% stratagems "8042"
)

findstr /I /M "D0QUESTPACK.TP2~.*#.*#4./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @429 | %C% >> %E%
) else (
%IFN% BWP_BP_AI Call %INSTI% stratagems "8050"
)

findstr /I /M "Tactics.TP2~.*#.*#2./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @430 | %C% >> %E%
) else (
%IFN% BWP_BP_AI %IFT% Call %INSTI% stratagems "8061"
)

findstr /I /M "Tactics.TP2~.*#.*#4./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @432 | %C% >> %E%
) else (
%IFN% BWP_BP_AI %IFT% Call %INSTI% stratagems "8081"
)

findstr /I /M "Tactics.TP2~.*#.*#5./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @433 | %C% >> %E%
) else (
%IFN% BWP_BP_AI %IFT% Call %INSTI% stratagems "8100"
)

findstr /I /M "Tactics.TP2~.*#.*#3./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%stratagems.exe %TXT% | findstr @434 | %C% >> %E%
) else (
%IFT% Call %INSTI% stratagems "8110"
)

%IFT% Call %INSTI% stratagems "8070 8090 8120 8130 8141 8150 8160 8170 8180 8190"

Call %INST% Volcano "0"

findstr /I /M "REVISEDBATTLES.TP2~.*#.*#9./ FIRKRAAG.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BuTcHeRy.exe %TXT% | findstr @355 | %C% >> %E%
) else (
%IFT% Call %INSTI% BuTcHeRy "0 1 2"
)

%IFSD% Call %INSTI% NMR "0 1 2 3 4 5 6 7 8"

findstr /I /M "NMR.TP2~.*#.*#0./ NMR.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% NMR-Happy "2"
) else (
%IFS%NMR-Happy.exe %TXT% | findstr @366 | %C% >> %E%
)

%IFN% BWP_BP_AI %IFT% Call %INSTI% Tactics "19"

:: BP AI
Call %INSTI% BP "325 440 475 550 600 625 650 675 725 750 760 800 875 900 925 1000"
%IFN% BWP_SCS_AI Call %INSTI% BP "150 350 375 390 400 425 500 525 575 700"

%IFX% Call %INSTI% MTS_Crappack "5 8"
:: components 13, 14, 15, 16 will break the game!

findstr /I /M "BP.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "D0QUESTPACK.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% MTS_Crappack "29"
)

findstr /I /M "BP.TP2~.*#.*#0./" WeiDU.log>nul && findstr /I /M "KELSEY.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFSD% Call %INST% MTS_Crappack "31"
)

Call %INSTI% BGTTweak "100 400 600 800 901 1000"
%IFS%BGTTweak.exe %TXT% | findstr @340 | %C% >> %E%
%IFNT% Call %INSTI% BGTTweak "1104"
Call %INSTI% BGTTweak "1200 1300 1502"
findstr /I /M "BG1UB.TP2~.*#.*#16./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @341 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1400"
)
findstr /I /M "ALORA.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#2./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @342 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1800"
)
findstr /I /M "BRANWENNPC.TP2~.*#.*#0./ POB.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#2./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @343 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1801"
)
findstr /I /M "ELDOTH.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @344 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1802"
)
findstr /I /M "TDD.TP2~.*#.*#0./ ACBRE.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#4./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @345 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1803"
)
findstr /I /M "TDD.TP2~.*#.*#0./ KIVAN.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#6./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @346 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1804"
)
findstr /I /M "BGTNEJ2.TP2~.*#.*#3./ NEJ2v68.TP2~.*#.*#6./ NEJ2v691.TP2~.*#.*#6./ TDD.TP2~.*#.*#0./ SHARTEEL.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @347 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1805"
)
findstr /I /M "SKIE.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @348 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1806"
)
findstr /I /M "XAN.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#8./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @349 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1807"
)
findstr /I /M "TDD.TP2~.*#.*#0./ BG1NPCSOA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BGTTweak.exe %TXT% | findstr @356 | %C% >> %E%
) else (
Call %INSTI% BGTTweak "1808"
)
findstr /I /M "DSOTSC.TP2~.*#.*#5./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BGTTweak "1809 1810 1811 1812 1813 1814"
)
findstr /I /M "NTOTSC.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BGTTweak "1815"
)
%IFS%BP-Balancer.exe Call %INSTI% BGTTweak "1900"
Call %INSTI% BGTTweak "2001 2100 2300 2500 2600 2700 2800"

findstr /I /M "STRATAGEMS.TP2~.*#.*#4040./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BGTTweak "2400"
)

%IFNS%1PP_THIEVES_GALORE.exe %IFN% .\1pp\core\1ppv4_pro Call %INSTI% BG2_Tweaks "50 120"
%MAC% Call %INSTI% BG2_Tweaks "50 120"
Call %INSTI% BG2_Tweaks "60 70 110 130 1010 1020 1040 1090 1120 1130"

findstr /I /M "CLIFFHISTORY.TP2~.*#.*#0./ OVERSIGHT.TP2~.*#.*#5./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG2_Tweaks.exe %TXT% | findstr @335 | %C% >> %E%
) else (
Call %INSTI% BG2_Tweaks "1161"
)

findstr /I /M "FR_ROV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG2_Tweaks.exe %TXT% | findstr @336 | %C% >> %E%
) else (
Call %INSTI% BG2_Tweaks "1170"
)

Call %INSTI% BG2_Tweaks "1180 2040 2050 2090 2192"
%IFXNS%refinements.exe Call %INSTI% BG2_Tweaks "2200"

findstr /I /M "TDD.TP2~.*#.*#0./ BP.TP2~.*#.*#14./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%BG2_Tweaks.exe %TXT% | findstr @337 | %C% >> %E%
) else (
Call %INSTI% BG2_Tweaks "2210"
)

:: components 2240, 2250, 2260, 2270, 2280, 2290 will be skipped, if one of the conflicting mods is installed
Call %INSTI% BG2_Tweaks "2240 2250 2260 2270 2280 2290"

Call %INSTI% BG2_Tweaks "2300 2320 2330 2340 3050 3060 3121 3125"

findstr /I /M "SAERILETH.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% BG2_Tweaks "3183" "TYPE bg2tweaks_with_Saerileth_input.txt"
) else (
Call %INSTI% BG2_Tweaks "3183" "TYPE bg2tweaks_without_Saerileth_input.txt"
)

:: The components 3031 "100% spell learn" and 3190 "Rest Anywhere" can be considerd as a cheat an thus are skipped.
:: Call %INSTI% BG2_Tweaks "3031 3190"

Call %INSTI% BG2_Tweaks "4000 4010 4031 4041 4050 4061 4071 4100 4110"

%IFI% Call %INSTI% Turambar_fixes_tweaks "10"
Call %INSTI% Turambar_fixes_tweaks "11 12 13 14 15 16 17 18 1055 1060 2000 2003 2004 2005 2007 2010 2020 2023 2050 2051 2052"

findstr /I /M "DIVINE_REMIX.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==1 (
Call %INSTI% Turambar_fixes_tweaks "2045 4010 4020 5005 5006"
)

%IFN2% %IFG% Call %INST% JA#BGT_Tweak "0"
findstr /I /M "NPC_TWEAK.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%JA#BGT_TWEAK.exe %TXT% | findstr @367 | %C% >> %E%
) else (
Call %INSTI% JA#BGT_TWEAK "14"
)
%IFN2% (
Call %INSTI% JA#BGT_Tweak "2 3 6 10 11 12 20 21 22 24 25 26 27 28 29 31 32"
%IFG% Call %INST% JA#BGT_Tweak "23"
)
findstr /I /M "SPELL_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%d0tweak.exe %TXT% | findstr @339 | %C% >> %E%
) else (
%IFSD% Call %INSTI% d0tweak "0"
)

%IFSD% Call %INSTI% d0tweak "4 5 6"

findstr /I /M "ITEM_REV.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%d0tweak.exe %TXT% | findstr @357 | %C% >> %E%
) else (
%IFSD% Call %INSTI% d0tweak "11"
)

%IFSNS%item_rev.exe Call %INSTI% d0tweak "18"

Call %INST% NMTP "0 2"
%IFN2% Call %INSTI% NMTP "3 4 5"

%IFN2% Call %INST% NML "0"

%IFN% BWP_CImpSummon Call %INST% gMinion "0"

%IFN% BWP_CgMinion %IFT% Call %INSTI% IMPROVEDSUMMONS "0 1 2 3 4 5 6 7 8 9 10"

%IFT% Call %INST% BPSERIES "0 1 2"

%IFT% Call %INST% NMRF-PC "0 2 3"

Call %INSTI% refinements "30"

echo 147 RemoveSpellRES(S:Spell*) >> override/action.ids
findstr /I /M "KONTWK.TP2~.*#.*#9./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%aTweaks.exe %TXT% | findstr @360 | %C% >> %E%
) else (
Call %INSTI% aTweaks "120"
)
Call %INSTI% aTweaks "100 101 102 103 104 110 115 125 130 140 152 160 180 185 186 190 191 200 201 202 203 204 205 210 211 212 213 216 218 220 230 239 261 270"
%IFS%ajantisbg2.exe %IF% ".\override\C#AJCUD1.bcs" move ".\override\C#AJCUD1.bcs" "%TEM%" | %M%
Call %INSTI% aTweaks "324"
%IFS%ajantisbg2.exe %IF% "%TEM%\C#AJCUD1.bcs" move "%TEM%\C#AJCUD1.bcs" ".\override" | %M%
Call %INSTI% aTweaks "301 302 310 315 500 510 999"

findstr /I /M "ASHESOFEMBERS.TP2~.*#.*#4./ KONTWK.TP2~.*#.*#0./ KITANYA.TP2~.*#.*#1./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%WSR.exe %TXT% | findstr @386 | %C% >> %E%
) else (
%IFSD% Call %INSTI% WSR "200 302 999"
)

Call %INSTI% RR "2 5 12 999"

findstr /I /M "RR.TP2~.*#.*#4./ RR.TP2~.*#.*#5./" WeiDU.log>nul
if %errorlevel%==0 (
%IFX% Call %INSTI% BardSong_BG2_IWD "1"
) else (
%IFX% Call %INSTI% BardSong_BG2_IWD "0"
)

%IFSD% Call %INSTI% DiffTweak "3 7 17 24"
findstr /I /M "TDD.TP2~.*#.*#0./ BP.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%DiffTweak.exe %TXT% | findstr @358 | %C% >> %E%
) else (
%IFSD% Call %INSTI% DiffTweak "42"
)

%IF% BWP_FULLPLATE Call %INST% fullplate "1 102 204"

%IFSD% Call %INSTI% randomiser "1300" "TYPE randomiser_input.txt"
%IFSD% Call %INSTI% randomiser "9000"
%IFT% Call %INSTI% randomiser "10200"
%IFSD% Call %INSTI% randomiser "10210"

%IFSD% Call %INSTI% tb#tweaks "100 150 200 300 1250"
%IFT% Call %INST% tb#tweaks "2050"
%IFSI% BWP_DUNGDRAG Call %INSTI% tb#tweaks "4000 4500 5000 5500 6000 6500"
findstr /I /M "ITEM_REV.TP2~.*#.*#15./ DIVINE_REMIX.TP2~.*#.*#403./ DIVINE_REMIX.TP2~.*#.*#409./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%tb#tweaks.exe %TXT% | findstr @373 | %C% >> %E%
) else (
Call %INSTI% tb#tweaks "7000"
)
Call %INSTI% tb#tweaks "9100"

findstr /I /M "TOBEX.TP2~.*#.*#121./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%P5Tweaks.exe %TXT% | findstr @361 | %C% >> %E%
) else (
Call %INSTI% P5Tweaks "10"
)
findstr /I /M "TOBEX.TP2~.*#.*#120./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%P5Tweaks.exe %TXT% | findstr @362 | %C% >> %E%
) else (
Call %INSTI% P5Tweaks "20"
)
findstr /I /M "TOBEX.TP2~.*#.*#122./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%P5Tweaks.exe %TXT% | findstr @363 | %C% >> %E%
) else (
Call %INSTI% P5Tweaks "40"
)

Call %INSTI% P5Tweaks "30 50"
findstr /I /M "ITEM_REV.TP2~.*#.*#17./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%P5Tweaks.exe %TXT% | findstr @364 | %C% >> %E%
) else (
Call %INSTI% P5Tweaks "60"
)

Call %INST% trap_rev "0"

Call %INST% contain "10"

%IFSD% Call %INST% celestiales "0 1 2"
%.%
%.%
%.%26. CLOSER INSTALLATION | %M%
%.%
%.%
Call ".\%BWIP%\define_BIG.bat

findstr "0 1" count2.txt
if %errorlevel%==0 (
Call %INST% xpmod "0 11"
)
findstr "2 3 4 5 6 7" count2.txt
if %errorlevel%==0 (
Call %INST% xpmod "1 12"
)

findstr /I /M "SETUP-ATWEAKS.TP2~.*#.*#261./" WeiDU.log>nul
if %errorlevel%==0 (
%IFN2% Call %INSTI% BP-Balancer "1 6 11"
) else (
%IFN2% Call %INSTI% BP-Balancer "2 7 12"
)
%IFN2% Call %INSTI% BP-Balancer "16 17 21 24 27 30"

%IFSD% Call %INSTI% iiSpellSystemAdjustments "0" "TYPE iiSpellSystemAdjustments_0_input.txt"
%IFSD% Call %INSTI% iiSpellSystemAdjustments "1" "TYPE iiSpellSystemAdjustments_1_input.txt"
%IFSD% Call %INSTI% iiSpellSystemAdjustments "2" "TYPE iiSpellSystemAdjustments_2_input.txt"
%IFSD% Call %INSTI% iiSpellSystemAdjustments "3" "TYPE iiSpellSystemAdjustments_3_input.txt"

%IFSD% Call %INST% iiProjectileR "2002" "TYPE iiProjectileR_input.txt"

%IFSD% Call %INST% iiLearnThroughuse "2001" "TYPE iiLearnThroughUse_input.txt"

Call %INST% aurora "0 10"
:: Call %INST% aurora "40 60"
:: Does not work correctly; no mousepointer finger

findstr "0 1" count2.txt
if %errorlevel%==0 (
Call %INST% aurora "115 170 215 247 420 470 500"
)

findstr "2 3 4 5 6 7" count2.txt
if %errorlevel%==0 (
Call %INSTI% aurora "105 180 210 247 420 467 500"
)

%IFN2% Call %INSTI% aurora "520"

%IFNS%infinityanimations.exe Call %INSTI% aurora "9000"
findstr /I /M "AURORA.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INST% aurpatch "0"
Call %INST% tobaurora "0"
)

%IFN2% %IFT% Call %INST% HardTimes "0 1"

Call %INST% level1npcs "0"
findstr /I /M "DIVINE_REMIX.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call %INSTI% level1npcs "1" "TYPE level1npcs_with_Druid_Remix_input.txt"
) else (
Call %INSTI% level1npcs "1" "TYPE level1npcs_without_Druid_Remix_input.txt"
)
Call %INSTI% level1npcs "3 51 55 60 100"

:: The regular expressions from Level1NPC don't consider the additions ("tF" and "tw") to the names made by Refinements and thus they corrupt the lines.
findstr /I /M "REFINEMENTS.TP2~.*#.*#10./" WeiDU.log>nul
if %errorlevel%==0 (
copy ".\level1npcs\backup\0\kit.ids" ".\override" | %M%
)

%IFX% Call %INST% Virtue "0"

%IFSD% Call %INST% gloran "1"

%IFX% Call %INST% w_psionics_unleashed "10 61"

findstr /I /M "1PP.TP2~.*#.*#203./ 1PP.TP2~.*#.*#204./" WeiDU.log>nul
if %errorlevel%==0 (
%IFS%infinityanimations.exe %TXT% | findstr @385 | %C% >> %E%
) else (
%IFN2% Call %INSTI% infinityanimations "8030 9520"
)

findstr /I /M "INFINITYANIMATIONS.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
copy /Y ".\%BWFP%\_override\infinityanimations\*.*" ".\override" | %M%
)

Call %INST% BP-BGT-Worldmap "0" "TYPE BP-BGT-Worldmap_input.txt"
Call %INST% BP-BGT-Worldmap "1"

Call %INSTI% BG2_Tweaks "3220"

Call %INST% mapnames "0 25"

findstr /I /M "BGT.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
Call ".\%BWIP%\define_GUI.bat
) else (
GOTO :SKIPGUI
)

FOR /F %%a IN ('type GUI_input.txt') DO Call %INST% GUI "%%a"

del count*.txt
del GUI_input.txt
del dir*.txt
del *.count*

:SKIPGUI

%IFX% %IF% BWP_TUTUGUI Call %INST% TutuGUI "0"
%IF% BWP_TUTUGUI %IF% BWP_widescreen_input.txt Call %INST% TutuGUI "1"

%IFX% %IF% BWP_W_GUI Call %INST% W_GUI "0 11"

%NMAC% %IFN% BWP_NoWide Call %INST% widescreen "0" "TYPE BWP_widescreen_input.txt"

Call %INST% crefixer "0"

%IFS%LongerRoad.exe %IF% ".\override\ahjon.BCS" move ".\override\ahjon.BCS" "%TEM%" | %M%
%IFNS%BPSeries.exe Call %INST% Innate_Fix "0"
%IFS%LongerRoad.exe %IF% "%TEM%\ahjon.BCS" move "%TEM%\ahjon.BCS" ".\override" | %M%

Call %INST% poison_effect_supplement "0"

%IF% lolfixer_ONLY_DEBUG_MODE.bat (
%TXT% | findstr @159 | %C%
rem call lolfixer_ONLY_DEBUG_MODE.bat
)
Call %INSTI% lolfixer "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15"

:: trim leading and trailing spaces; remove duplicates
Call ".\%BWIP%\trim_IDS.bat" 
Call ".\%BWIP%\trim_KitIDS.bat"

:: Hotfixes
findstr /I /M "ROT.TP2~.*#.*#0./" WeiDU.log>nul
if %errorlevel%==0 (
copy /Y ".\%BWFP%\_Hotfixes\RoT\dltcepsmithy\*.*" ".\override" | %M%
)

%IFS%Derats_kits.exe %IF% "%TEM%\pxw8copi.spl" move "%TEM%\pxw8copi.spl" ".\override" | %M%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
:: biff override
%IFS%generalized_biffing.exe %TXT% | findstr @090 | %C%
%.%
%.%
%.%
%.%
Call %INST% generalized_biffing "0" 1
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
:: crack
%NMAC% %NGOG% %IF% NoCD.exe %TXT% | findstr @091 | %C%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%NMAC% %NGOG% %IF% NoCD.exe pause
%NMAC% %NGOG% %IF% NoCD.exe NoCD.exe | %M%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%

:BWSEnd

%.%
%.%
%.%
%.%
%.%
%.%
:: list not installed mods
%TXT% | findstr @092 | %C%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
pause
%.%
%.%
CALL "%BWIP%\List.bat" INI& rem list not installed mods
%.%
%.%
%TXT% | findstr @140 | %C%
%.%
%IFS%btweak.DEBUG %IFS%btweak_lite.exe %TXT% | findstr @133 | %C%
%IFS%BGTNeJ2%IFNIF%NeJ2.exe %TXT% | findstr @136 | %C%
%IFS%BGTNeJ%IFNIF%NeJ2.exe %TXT% | findstr @137 | %C%
%IF% BWP_CPerils %TXT% | findstr @121 | %C%
%IF% BWP_CBranwen %TXT% | findstr @121 | %C%
%IF% BWP_CCoranBG2 %TXT% | findstr @123 | %C%
%IF% BWP_CImoenFriend %TXT% | findstr @134 | %C%
%IF% BWP_CImoenRom %TXT% | findstr @134 | %C%
%IF% BWP_CRoTDrizzt %TXT% | findstr @124 | %C%
%IF% BWP_COctDrizzt %TXT% | findstr @124 | %C%
%IFNS%ValHorn.DEBUG %IFS%Item_Rev.DEBUG %TXT% | findstr @122 | %C%
%IFS%JondalarFix.exe %IFNE% %TXT% | findstr @129 | %C%
%IF% BWP_CNoKkalid %TXT% | findstr @127 | %C%
%IF% BWP_CKhalid %TXT% | findstr @127 | %C%
%IF% BWP_CDArnise %TXT% | findstr @132 | %C%
%IF% BWP_CLuvNalia %TXT% | findstr @132 | %C%
%IFS%NeJ2Biffer%IFNIF%NeJ2.exe %TXT% | findstr @139 | %C%
%IFS%NeJ2v602%IFNIF%NeJ2.exe %TXT% | findstr @135 | %C%
%IF% BWP_CTDDSharTeel %TXT% | findstr @126 | %C%
%IF% BWP_CSharTeel %TXT% | findstr @126 | %C%
%IFNS%Spell50.DEBUG %IFS%spell_rev.exe %TXT% | findstr @128 | %C%
%IFS%mapnames.exe %IFNE% %TXT% | findstr @141 | %C%
%IF% BWP_CYoshFriend %TXT% | findstr @125 | %C%
%IF% BWP_CKeepYosh %TXT% | findstr @125 | %C%
%IF% BWP_CgMinion %TXT% | findstr @146 | %C%
%IF% BWP_CImpSummon %TXT% | findstr @147 | %C%
%.%
type "BiG World Explanation.txt"
%.%
%.%
pause
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
%.%
:: installation complete
%TXT% | findstr @093 | %C%
%.%
%.%
%.%
%.%
:: level1
%IFS%level1npc.exe %TXT% | findstr @094 | %C%
%.%
%.%
%.%
:: clean-up
%TXT% | findstr @095 | %C%
%.%
%.%
%.%
%.%
del 1
del 2
del 3
del 4
del 5
del BWP*
::del "Start BW Install.nul"
type NUL> "BiG World Install.nul"
%.%
%.%
%.%
%.%
pause

:EXIT


:: Copyright 2008/2009/2010/2011/2012/2013/2014 by Leonardo Watson
:: This file or parts of it may not be copied or changed without permission.